"use strict";

const React = require("react");

const MainLayout = require("../layout");
const MenuItem = require("../components/menu-item");

const prefixTitle = require("../../prefix-title");

function Submenu() {
	return (<>
		<MenuItem path="/hardware/system-information">System Information</MenuItem>
		<MenuItem path="/hardware/storage-devices">Storage Devices</MenuItem>
		<MenuItem path="/hardware/network-interfaces">Network Interfaces</MenuItem>
	</>);
}

module.exports = function HardwareLayout({ children, title }) {
	return (
		<MainLayout submenu={<Submenu />} title={prefixTitle("Hardware >", title)}>
			{children}
		</MainLayout>
	);
};